"""create-queue-states

Revision ID: 348ea50d3be1
Revises: b56126666d80
Create Date: 2021-10-13 14:24:29.779476

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "348ea50d3be1"
down_revision = "b56126666d80"
branch_labels = None
depends_on = None


def upgrade():
    op.execute(
        """
    update capability_state_transitions 
    set pattern = 'event_type == resume' 
    where pattern = 'event_type == workflow-executing'
    """
    )
    op.execute(
        """
    insert into capability_state_actions (transition_id, action_type, arguments)
    select transition_id, 'ExecuteWorkflow', capability_name as arguments
    from capability_state_transitions where pattern = 'event_type == resume';
    """
    )


def downgrade():
    op.execute(
        """
    update capability_state_transitions 
    set pattern = 'event_type == workflow-executing' 
    where pattern = 'event_type == resume'
    """
    )
    op.execute(
        """
    delete from capability_state_actions 
    where action_type = 'ExecuteWorkflow'
    """
    )
