"""WS-717-fix-capability-name-foreign-keys

Revision ID: c3f9f47e7b4f
Revises: 348ea50d3be1
Create Date: 2021-10-13 16:31:38.066947

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "c3f9f47e7b4f"
down_revision = "348ea50d3be1"
branch_labels = None
depends_on = None


def upgrade():
    op.execute(
        """
        ALTER TABLE capability_versions ADD COLUMN capability_name varchar REFERENCES capabilities(capability_name);
        UPDATE capability_versions SET capability_name = req.capability_name FROM capability_requests req
        WHERE capability_versions.capability_request_id = req.capability_request_id;
        ALTER TABLE capability_versions ALTER COLUMN capability_name SET NOT NULL;
        
        ALTER TABLE capability_executions ADD COLUMN capability_name varchar REFERENCES capabilities(capability_name);
        UPDATE capability_executions SET capability_name = v.capability_name FROM capability_versions v
        WHERE capability_executions.capability_version_number = v.version_number AND capability_executions.capability_request_id = v.capability_request_id;
        ALTER TABLE capability_executions ALTER COLUMN capability_name SET NOT NULL;
        
        ALTER TABLE capability_executions ADD CONSTRAINT capability_execution_state_fkey FOREIGN KEY (capability_name, state) REFERENCES capability_states(capability_name, state);
    """
    )


def downgrade():
    op.execute(
        """
        ALTER TABLE capability_executions DROP COLUMN capability_name;
        ALTER TABLE capability_versions DROP COLUMN capability_name;
    """
    )
